summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorBen Peart <peartben@gmail.com>2017-06-01 11:51:03 -0400
committerJunio C Hamano <gitster@pobox.com>2017-06-02 10:51:27 +0900
commitff731efedca3f9f2938b60d55a96f9de0ee01679 (patch)
treeee37cbd184667c2d9f2cb10a1cbca2ccc991563e
parentfe3d3f91a6a2eb3b193f79e661f3ef36736e2757 (diff)
downloadgit-ff731efedca3f9f2938b60d55a96f9de0ee01679.tar.gz
fsmonitor: add test cases for fsmonitor extension
Add test cases that ensure status results are correct when using the new fsmonitor extension. Test untracked, modified, and new files by ensuring the results are identical to when not using the extension. Add a test to ensure updates to the index properly mark corresponding entries in the index extension as dirty so that the status is correct after commands that modify the index but don't trigger changes in the working directory. Add a test that verifies that if the fsmonitor extension doesn't tell git about a change, it doesn't discover it on its own. This ensures git is honoring the extension and that we get the performance benefits desired. All test hooks output a marker file that is used to ensure the hook was actually used to generate the test results. Signed-off-by: Ben Peart <benpeart@microsoft.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>
-rwxr-xr-xt/t7519-status-fsmonitor.sh173
1 files changed, 173 insertions, 0 deletions
diff --git a/t/t7519-status-fsmonitor.sh b/t/t7519-status-fsmonitor.sh
new file mode 100755
index 0000000000..458eabe6dc
--- /dev/null
+++ b/t/t7519-status-fsmonitor.sh
@@ -0,0 +1,173 @@
+#!/bin/sh
+
+test_description='git status with file system watcher'
+
+. ./test-lib.sh
+
+clean_repo () {
+ git reset --hard HEAD &&
+ git clean -fd &&
+ rm -f marker
+}
+
+dirty_repo () {
+ : >untracked &&
+ : >dir1/untracked &&
+ : >dir2/untracked &&
+ echo 1 >modified &&
+ echo 2 >dir1/modified &&
+ echo 3 >dir2/modified &&
+ echo 4 >new &&
+ echo 5 >dir1/new &&
+ echo 6 >dir2/new &&
+ git add new &&
+ git add dir1/new &&
+ git add dir2/new
+}
+
+# The test query-fsmonitor hook proc will output a marker file we can use to
+# ensure the hook was actually used to generate the correct results.
+
+# fsmonitor works correctly with or without the untracked cache
+# but if it is available, we'll turn it on to ensure we test that
+# codepath as well.
+
+test_lazy_prereq UNTRACKED_CACHE '
+ { git update-index --test-untracked-cache; ret=$?; } &&
+ test $ret -ne 1
+'
+
+if test_have_prereq UNTRACKED_CACHE; then
+ git config core.untrackedcache true
+else
+ git config core.untrackedcache false
+fi
+
+test_expect_success 'setup' '
+ mkdir -p .git/hooks &&
+ : >tracked &&
+ : >modified &&
+ mkdir dir1 &&
+ : >dir1/tracked &&
+ : >dir1/modified &&
+ mkdir dir2 &&
+ : >dir2/tracked &&
+ : >dir2/modified &&
+ git add . &&
+ test_tick &&
+ git commit -m initial &&
+ git config core.fsmonitor true &&
+ cat >.gitignore <<-\EOF
+ .gitignore
+ expect*
+ output*
+ marker*
+ EOF
+'
+
+# Ensure commands that call refresh_index() to move the index back in time
+# properly invalidate the fsmonitor cache
+
+test_expect_success 'refresh_index() invalidates fsmonitor cache' '
+ git status &&
+ test_path_is_missing marker &&
+ dirty_repo &&
+ write_script .git/hooks/query-fsmonitor<<-\EOF &&
+ :>marker
+ EOF
+ git add . &&
+ git commit -m "to reset" &&
+ git status &&
+ test_path_is_file marker &&
+ git reset HEAD~1 &&
+ rm -f marker &&
+ git status >output &&
+ test_path_is_file marker &&
+ git -c core.fsmonitor=false status >expect &&
+ test_i18ncmp expect output
+'
+
+# Now make sure it's actually skipping the check for modified and untracked
+# files unless it is told about them. Note, after "git reset --hard HEAD" no
+# extensions exist other than 'TREE' so do a "git status" to get the extension
+# written before testing the results.
+
+test_expect_success "status doesn't detect unreported modifications" '
+ write_script .git/hooks/query-fsmonitor<<-\EOF &&
+ :>marker
+ EOF
+ clean_repo &&
+ git status &&
+ test_path_is_missing marker &&
+ : >untracked &&
+ echo 2 >dir1/modified &&
+ git status >output &&
+ test_path_is_file marker &&
+ test_i18ngrep ! "Changes not staged for commit:" output &&
+ test_i18ngrep ! "Untracked files:" output &&
+ write_script .git/hooks/query-fsmonitor<<-\EOF &&
+ :>marker
+ printf "untracked\0"
+ printf "dir1/modified\0"
+ EOF
+ rm -f marker &&
+ git status >output &&
+ test_path_is_file marker &&
+ test_i18ngrep "Changes not staged for commit:" output &&
+ test_i18ngrep "Untracked files:" output
+'
+
+# Status is well tested elsewhere so we'll just ensure that the results are
+# the same when using core.fsmonitor. First call after turning on the option
+# does a complete scan so we need to do two calls to ensure we test the new
+# codepath.
+
+test_expect_success 'status with core.untrackedcache false' '
+ git config core.untrackedcache false &&
+ write_script .git/hooks/query-fsmonitor<<-\EOF &&
+ if [ $1 -ne 1 ]
+ then
+ echo -e "Unsupported query-fsmonitor hook version.\n" >&2
+ exit 1;
+ fi
+ : >marker
+ printf "untracked\0"
+ printf "dir1/untracked\0"
+ printf "dir2/untracked\0"
+ printf "modified\0"
+ printf "dir1/modified\0"
+ printf "dir2/modified\0"
+ printf "new\0""
+ printf "dir1/new\0"
+ printf "dir2/new\0"
+ EOF
+ clean_repo &&
+ dirty_repo &&
+ git -c core.fsmonitor=false status >expect &&
+ clean_repo &&
+ git status &&
+ test_path_is_missing marker &&
+ dirty_repo &&
+ git status >output &&
+ test_path_is_file marker &&
+ test_i18ncmp expect output
+'
+
+if ! test_have_prereq UNTRACKED_CACHE; then
+ skip_all='This system does not support untracked cache'
+ test_done
+fi
+
+test_expect_success 'status with core.untrackedcache true' '
+ git config core.untrackedcache true &&
+ git -c core.fsmonitor=false status >expect &&
+ clean_repo &&
+ git status &&
+ test_path_is_missing marker &&
+ dirty_repo &&
+ git status >output &&
+ test_path_is_file marker &&
+ test_i18ncmp expect output
+'
+
+test_done